/*
 * Copyright (c) 2024 The Arizona Board of Regents on behalf of the University 
 * of Arizona. All rights reserved.
 * 
 * This file is part of Astrolabe. Astrolabe is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General Public 
 * License as  published by the Free Software Foundation, either version 3 of 
 * the License, or  (at your option) any later version. Astrolabe is distributed
 * in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See 
 * the GNU General Public License for more details. You should have received a 
 * copy of the GNU General Public License along with Astrolabe. 
 * If not, see <https://www.gnu.org/licenses/>. 
 */
package astrolabe.metadata.ui;

import astrolabe.metadata.store.Store;
import astrolabe.metadata.store.StoreListener;
import java.util.Arrays;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.DefaultTableModel;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.windows.TopComponent;
import org.openide.util.NbBundle.Messages;

/**
 * Top component which displays something.
 */
@TopComponent.Description(
        preferredID = "StoreViewTopComponent",
        iconBase = "astrolabe/metadata/ui/hub-16.png",
        persistenceType = TopComponent.PERSISTENCE_ALWAYS
)
@TopComponent.Registration(mode = "rightSlidingSide", openAtStartup = false)
@ActionID(category = "Window", id = "astrolabe.metadata.ui.StoreViewTopComponent")
@ActionReference(path = "Menu/Window", position = 333)
@TopComponent.OpenActionRegistration(
        displayName = "#CTL_StoreViewAction",
        preferredID = "StoreViewTopComponent"
)
@Messages({
    "CTL_StoreViewAction=Metadata Store",
    "CTL_StoreViewTopComponent=Metadata Store",
    "HINT_StoreViewTopComponent=This is a Metadata Store window"
})
public final class StoreViewTopComponent extends TopComponent implements StoreListener {

    private static final Logger LOG = Logger.getLogger(StoreViewTopComponent.class.getName());

    public StoreViewTopComponent() {
        LOG.log(Level.INFO, new Throwable().getStackTrace()[0].toString());
        initComponents();
        setName(Bundle.CTL_StoreViewTopComponent());
        setToolTipText(Bundle.HINT_StoreViewTopComponent());
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        storeTableScrollPane = new javax.swing.JScrollPane();
        storeTable = new javax.swing.JTable();

        storeTableScrollPane.setAutoscrolls(true);

        storeTable.setAutoCreateRowSorter(true);
        storeTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Key", "Value"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        storeTableScrollPane.setViewportView(storeTable);
        if (storeTable.getColumnModel().getColumnCount() > 0) {
            storeTable.getColumnModel().getColumn(0).setHeaderValue(org.openide.util.NbBundle.getMessage(StoreViewTopComponent.class, "StoreViewTopComponent.storeTable.columnModel.title0")); // NOI18N
            storeTable.getColumnModel().getColumn(1).setHeaderValue(org.openide.util.NbBundle.getMessage(StoreViewTopComponent.class, "StoreViewTopComponent.storeTable.columnModel.title1")); // NOI18N
        }

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(storeTableScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(storeTableScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable storeTable;
    private javax.swing.JScrollPane storeTableScrollPane;
    // End of variables declaration//GEN-END:variables
    @Override
    public void componentOpened() {
        Set<String> ks = Store.getKeys();
        String[] keys = ks.toArray(String[]::new);
        Arrays.sort(keys);

        DefaultTableModel dtm = new DefaultTableModel() {
            private static final long serialVersionUID = 2793957061432039023L;

            @Override
            public boolean isCellEditable(int row, int col) {
                return false;
            }
        };
        dtm.setColumnIdentifiers(new String[]{"Key", "Value"});
        for (String key : keys) {
            dtm.addRow(new String[]{key, Store.get(key)});
        }
        storeTable.setModel(dtm);
        StoreViewTableCellRenderer.set(storeTable, 0);

        Store.addListener(this);
    }

    @Override
    public void componentClosed() {
        Store.removeListener(this);
    }

    @Override
    public void dataModified(String key, String oldVal, String newVal) {
        // Short circuit this if they key is an authorization token.
        LOG.log(Level.INFO, "key={0}, oldVal={1}, newVal={2}", new Object[]{key, oldVal, newVal});
        if (key.endsWith("token")) {
            newVal = "*".repeat(newVal.length());
            LOG.log(Level.INFO, "key={0}, oldVal={1}, newVal={2}", new Object[]{key, oldVal, newVal});
        }

        // Get the current table model.
        DefaultTableModel dtm = (DefaultTableModel) storeTable.getModel();
        boolean mod = false;

        // If this value is already in the table, modify it.
        for (int i = 0; i < dtm.getRowCount(); i++) {
            String k = (String) dtm.getValueAt(i, 0);
            if (k.compareTo(key) == 0) {
                dtm.setValueAt(newVal, i, 1);
                mod = true;
            }
        }

        // If it's not already in the table, so add a row.
        if (!mod) {
            dtm.addRow(new String[]{key, newVal});
        }
    }
}
